<template>
    <div
        v-if="abandonedCarts && shop"
        class="page-container"
    >
        <div class="video-button-container">
            <add-credits v-if="$cookies.get('platform') === 'wix'" />
            <VideoButton :source="'https://carti.crisp.help/en/article/enable-sms-cart-abandonment-automation-1fnskde/reader'" />
        </div>
        <div>
            <div class="sms-title">
                Automate your sms abandoned cart sequence here!
            </div>
            <div class="sms-subtitle">
                *Pro-tip: Incentivize them in your last sms to encourage checkout!
            </div>
        </div>
        <div class="row">
            <EmailCard
                v-for="(card, index) in abandonedCarts"
                :key="index"
                class="col-lg-4"
                :cart-data="card"
                :loader="loading"
            />
        </div>
        <div v-show="!loading">
            <SmsAbandonedTable
                :data="data"
                @getAbandonedCarts="getAbandonedCarts"
            />
            <div class="add-reminder-container">
                <div>
                    <b-btn
                        class="btn blue-btn"
                        @click="createAbandonedCart"
                    >
                        Add Reminder
                    </b-btn>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import VideoButton from "@/components/header/VideoButton";
import SmsAbandonedTable from "@/components/sms/SmsAbandonedTable";
import EmailCard from "@/components/email/abandoned-cards/EmailCard";
import smsCarts from "@/mixins/sms/abandoned-carts.service";
import currencies from "@/data/currencies.json";
import shop from '@/mixins/shop.service';
import AddCredits from "@/components/pricing/AddCredits";

export default {
    name: "SmsAbandonedCarts",
    components: {AddCredits, EmailCard, SmsAbandonedTable, VideoButton},
    mixins: [smsCarts, shop],
    data: () => ({
        data: null,
        loading: true,
        shop: null,
        reminders: null,
        currencies: currencies,
        abandonedCarts: [
            {
                title: 'Revenue Recovered',
                icon: 'fa fa-window-maximize',
                salesCount: '0',
                salesTitle: 'Sales'
            },
            {
                title: 'Abandoned Carts',
                icon: 'fa fa-users',
                salesCount: '0',
                salesTitle: 'Quantity'
            },
            {
                title: 'Orders Recovered',
                icon: 'fa fa-cube',
                salesCount: '0',
                salesTitle: 'Quantity'
            }
        ],
        send_time: 72,
        send_time_type: {
            label: 'Hours',
            value: 'hours'
        },
        body_text: '{siteName}: Items you loved are running out. Get them for {discountValue}% OFF with {discountCode} code! Get it now: {cartLink}',
    }),
    computed: {
        getCurrencySign() {
            if (!this.currencies)
                return {
                    symbol: this.shop.payment_currency
                };
            return this.currencies[this.shop.payment_currency];
        }
    },
    created() {
        this.loadShop()
    },
    mounted() {
        this.getAbandonedCarts()
    },
    methods: {
        async loadShop() {
            this.shop = await this.getShop()
        },
        getAbandonedCarts() {
            this.data = null
            this.reminders = null
            this.getSmsAbandonedCarts().then(response => (this.data = response.data)).then(() => {
                this.reminders = this.data.reminders
                this.abandonedCarts = [
                    {
                        title: 'Revenue Recovered',
                        icon: 'fa fa-window-maximize',
                        salesCount: this.getCurrencySign.symbol_native + this.data.total_revenue,
                        salesTitle: 'Sales'
                    },
                    {
                        title: 'Abandoned Carts',
                        icon: 'fa fa-users',
                        salesCount: this.data.total_carts,
                        salesTitle: 'Quantity'
                    },
                    {
                        title: 'Orders Recovered',
                        icon: 'fa fa-cube',
                        salesCount: this.data.total_orders,
                        salesTitle: 'Quantity'
                    }
                ]
                this.loading = false
            }).catch(error => {
                console.log(error)
            });
        },
        createAbandonedCart() {
            this.createCart({
                send_time: this.send_time,
                send_time_type: this.send_time_type.value,
                body_text: this.body_text,
            }).catch(error => {
                console.log(error)
            })
        }
    }
}
</script>

<style scoped lang="scss">

.sms-title {
    font-size: 14px;
}

.dashboard-total-value {
    display: flex;
    align-items: center;
}

.total-revenue-count {
    font-size: 29px;
    color: rgb(51, 51, 51);
    font-weight: 800;
}

.total-revenue-text {
    font-size: 14px;
    margin-right: 10px;
    font-weight: 500;
}

.total-shopify-container {
    display: flex;
    justify-content: flex-end;
}

.total-revenue-container {
    display: flex;
    align-items: center;
    margin-right: 30px;
    padding: 3px 10px;
    justify-content: space-between;
    border-radius: 5px;
    -webkit-box-shadow: 0 5px 20px rgba(200, 208, 222, 0.2);
    box-shadow: 0 5px 20px rgba(200, 208, 222, 0.2);
    @media screen and (max-width: 1200px) {
        margin: 15px 0;
    }
    @media screen and (max-width: 950px) {
        .total-revenue-text {
            font-size: 12px;
        }
        .total-revenue-count {
            font-size: 23px;
        }
    }
    @media screen and (max-width: 600px) {
        flex-direction: column;
        align-items: center;

    }
}

.sms-subtitle {
    font-size: 11px;
    margin-bottom: 40px;
    margin-top: 3px;
}
@media(max-width: 475px) {
    .video-button-container {
        flex-direction: column;
        .btn_wrapper {
            margin-top: 10px;
        }
    }
}

</style>
